﻿using UnityEngine;
using System.Collections;

/**
 * This script is a container for all player modifiers including speed, cooldown times, health, etc.
 * */
[RequireComponent (typeof(scr_inputHandler))]
public class scr_player : MonoBehaviour {
	public bool canMove = false;
	public float health = 0.0f;
	public float speed = 5.0f;
	public float rotSpeed = 50.0f;
	public float fireDelay = 0.2f;
	public float slowTime = 0.45f;
	public GameObject modelSub;
	public GameObject smokeParticle;
	public GameObject deathParticle;
	public AudioClip death;
	public AudioClip hit;
	public AudioSource deathSource;
	public Transform projectile;
	public Transform projSpawn;
	public float Score = 0.0f;
	//This will detect game over likely, or tell a game manager to end the game and add score.

	void OnTriggerEnter(Collider other) {
		if (other.CompareTag ("Enemy")) {
			Debug.Log ("Hit by enemy");
			deathSource.clip = hit;
			deathSource.Play ();
			//TODO play animation for getting hit + sound
			health -= 2;
			Instantiate (deathParticle, transform.position, transform.rotation, transform);
		} else if (other.CompareTag ("Mine")) {
			health -=5;
		}
		if (health <= 0) {
			deathSource.clip = death;
			deathSource.Play ();
			Debug.Log ("You died! Press space to play again.");
			Instantiate (smokeParticle, transform.position, transform.rotation, transform);
			Time.timeScale = slowTime;
		}
	}

	/**
	 * Public function to add to players score
	 * */
	public void addToScore(float amount) {
		Score += amount;
	}

	/**
	 * Reset all parameters
	 * */
	public void reset() {
		transform.position = new Vector3 (0.0f, 0.0f, 0.0f);
		Score = 0.0f;
		health = 10.0f;
		canMove = true;
		Time.timeScale = 1.0f;
		GameObject[] particles = GameObject.FindGameObjectsWithTag ("Particle");
		for (int i = 0; i < particles.Length; i++) {
			Destroy (particles [i]);
		}
	}
}
